Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.ietf.jgss
Interface GSSName

    public interface GSSName

This interface encapsulates a single GSS-API principal entity. Different name formats and their definitions are identified with universal Object Identifiers (Oids). The format of the names can be derived based on the unique oid of its namespace type.

Based on the IETF RFC-2853.

Version:
  1.1 5/7/07
Author:
  Thomas Owusu

Field Summary
`static Oid` | `NT_ANONYMOUS` Name type for representing an anonymous entity.
`static Oid` | `NT_EXPORT_NAME` Name type used to indicate an exported name produced by the export method.
`static Oid` | `NT_HOSTBASED_SERVICE` Oid indicating a host-based service name form.
`static Oid` | `NT_MACHINE_UID_NAME` Name type to indicate a numeric user identifier corresponding to a user on a local system.
`static Oid` | `NT_STRING_UID_NAME` Name type to indicate a string of digits representing the numeric user identifier of a user on a local system.
`static Oid` | `NT_USER_NAME` Name type to indicate a named user on a local system.

Method Summary
`GSSName` | `canonicalize(Oid mech)` Creates a mechanism name (MN) from an arbitrary internal name.
`boolean` | `equals(GSSName otherName)` Compares two GSSName objects to determine whether they refer to the same entity.
`boolean` | `equals(java.lang.Object otherName)` A variation of the equals method that is provided to override the Object.equals() method that the implementing class will inherit.
`byte[]` | `export()` Returns a canonical contiguous byte representation of a mechanism name (MN), suitable for direct, byte by byte comparison by authorization functions.
`Oid` | `getStringNameType()` Returns the oid representing the type of name returned through the toString method.
`int` | `hashCode()` Returns a hashcode value for this GSSName.
`boolean` | `isAnonymous()` Tests if this name object represents an anonymous entity.
`boolean` | `isMN()` Tests if this name object contains only one mechanism element and is thus a mechanism name as defined by RFC 2078.
`java.lang.String` | `toString()` Returns a textual representation of the GSSName object.

Field Detail

### NT_HOSTBASED_SERVICE

    static final Oid NT_HOSTBASED_SERVICE

  Oid indicating a host-based service name form. It is used to represent services associated with host computers. This name form is constructed using two elements, "service" and "hostname", as follows:

  `service@hostname`

  Values for the "service" element are registered with the IANA. It represents the following value: { 1(iso), 3(org), 6(dod), 1(internet), 5(security), 6(nametypes), 2(gss-host-based-services) }.

### NT_USER_NAME

    static final Oid NT_USER_NAME

  Name type to indicate a named user on a local system. It represents the following value: { iso(1) member-body(2) United States(840) mit(113554) infosys(1) gssapi(2) generic(1) user_name(1) }

### NT_MACHINE_UID_NAME

    static final Oid NT_MACHINE_UID_NAME

  Name type to indicate a numeric user identifier corresponding to a user on a local system. (e.g. Uid). It represents the following value: { iso(1) member-body(2) United States(840) mit(113554) infosys(1) gssapi(2) generic(1) machine_uid_name(2) }

### NT_STRING_UID_NAME

    static final Oid NT_STRING_UID_NAME

  Name type to indicate a string of digits representing the numeric user identifier of a user on a local system. It represents the following value: { iso(1) member-body(2) United States(840) mit(113554) infosys(1) gssapi(2) generic(1) string_uid_name(3) }

### NT_ANONYMOUS

    static final Oid NT_ANONYMOUS

  Name type for representing an anonymous entity. It represents the following value: { 1(iso), 3(org), 6(dod), 1(internet), 5(security), 6(nametypes), 3(gss-anonymous-name) }

### NT_EXPORT_NAME

    static final Oid NT_EXPORT_NAME

  Name type used to indicate an exported name produced by the export method. It represents the following value: { 1(iso), 3(org), 6(dod), 1(internet), 5(security), 6(nametypes), 4(gss-api-exported-name) }

Method Detail

### equals

    boolean equals(GSSName otherName)
                   throws GSSException

  Compares two GSSName objects to determine whether they refer to the same entity. This method may throw a GSSException when the names cannot be compared. If either of the names represents an anonymous entity, the method will return "false".

  Parameters:
    `otherName` - GSSName object to compare with.
  Returns:
    "true" if the two GSSName objects refer to the same entity.
  Throws:
    `GSSException`

### equals

    boolean equals(java.lang.Object otherName)

  A variation of the equals method that is provided to override the Object.equals() method that the implementing class will inherit. The behaviour is exactly the same as other equals method except that no GSSException is thrown; instead, false will be returned in the situation where an error occurs.

  Overrides:
    `equals` in class `java.lang.Object`
  Returns:
    "true" if the two GSSName objects refer to the same entity.

### hashCode

    int hashCode()

  Returns a hashcode value for this GSSName.

  Overrides:
    `hashCode` in class `java.lang.Object`
  Returns:
    a hashCode value

### canonicalize

    GSSName canonicalize(Oid mech)
                         throws GSSException

  Creates a mechanism name (MN) from an arbitrary internal name. This is equivalent to using the factory methods `GSSManager.createName(String, Oid, Oid)` and `GSSManager.createName(byte[], Oid, Oid)` that take the mechanism name as one of their parameters.

  Parameters:
    `mechOid` - The oid for the mechanism for which the canonical form of the name is requested.
  Returns:
    The mechanism name for the specified mechanism.
  Throws:
    `GSSException`

### export

    byte[] export()
                  throws GSSException

  Returns a canonical contiguous byte representation of a mechanism name (MN), suitable for direct, byte by byte comparison by authorization functions. If the name is not an MN, implementations may throw a GSSException with the NAME_NOT_MN status code. If an implementation chooses not to throw an exception, it should use some system specific default mechanism to canonicalize the name and then export it. The format of the header of the output buffer is specified in RFC 2078.

  Returns:
    Byte array representing this mechanism name (MN).
  Throws:
    `GSSException`

### toString

    java.lang.String toString()

  Returns a textual representation of the GSSName object. To retrieve the printed name format, which determines the syntax of the returned string, the getStringNameType method can be used.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    A string form of this GSSName.

### getStringNameType

    Oid getStringNameType()
                          throws GSSException

  Returns the oid representing the type of name returned through the toString method. Using this oid, the syntax of the printable name can be determined.

  Returns:
    Oid representing the name type used in the `toString` method.
  Throws:
    `GSSException`

### isAnonymous

    boolean isAnonymous()

  Tests if this name object represents an anonymous entity. Returns "true" if this is an anonymous name.

  Returns:
    "true" if this name anonymous.

### isMN

    boolean isMN()

  Tests if this name object contains only one mechanism element and is thus a mechanism name as defined by RFC 2078.

  Returns:
    "true" if this is a mechanism name.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD